/***************************************************************************
                          kquick.h  -  description
                             -------------------
    begin                : Mit Dez 22 03:21:27 CET 1999
    copyright            : (C) 1999 by Philipp Ghring
    email                : p.guehring@poboxes.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KQUICK_H
#define KQUICK_H

#define i18n i18n
const char *i18n(const char *Text);

#include <kapp.h>
#include <ktmainwindow.h>
#include <qwidget.h>
#include <html.h>

class Quick;
class OutputC;
#include "quick.h"
#include "outputc.h"

class KQuick : public KTMainWindow
{
  Q_OBJECT
  public:
    /** HTML Widget, which receives the output */
    KHTMLView *htmlw;
    /** The ouput system */
    OutputC *output;
    /** Filehandle for the logfile, where we log all the queries  */
    FILE *logfile;
  public:
    /** This is a slot for the HTML Widget, that we can process all the clicks on Hyperlinks */
    void loadUrl(const char *_url,bool saveRecent=true);
    /** construtor */
    KQuick(QWidget* parent=0, const char *name=0);
    /** This function is called regulary to fetch the searchtext and generate the output */
    void timerEvent(QTimerEvent *ev);
    /** destructor */
    ~KQuick();
    /** The editbox, which contains the word to be translated. */
    QLineEdit * editbox;
    /** This is the main window */
    QWidget * topWidget;
    /** This is the Translator Interface, which queries all the databases */
    Quick *quick;
    /** Counts down until update */
    int CountDown;
  private: // Private attributes
    /** Tests for the existence of a given directory underneath $HOME and creates it
        if it doesn't exist. */
    void TestDir (const char* name);
    /** The Menu which includes all the options like logging, OnTopWhenNeeded, ... */
    QPopupMenu *optionmenu;
    /** Those are to remember the previous searchtext, to know wheter it changed */
    QString lastsearch,lastedit;

public slots: // Public slots
  /** Switches the logging on and off */
  void switchlog();
  /** Switches the AutoOnTop Feature on and off */
  void switchontop();
  /** */
  void slotOnURL ( KHTMLView *_view, const char *_url );
  /** Load document from Url when You select link in preview window */
  void slotLoadUrl (KHTMLView *_view, const char *_url, int _button, const char *_target );

};

#endif
