/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Mit Dez 22 03:21:27 CET 1999
    copyright            : (C) 1999 by Philipp Ghring
    email                : p.guehring@poboxes.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kquick.h"
#include "quick.h"
#include "outputc.h"
#include <kmsgbox.h>

extern bool logQueries;
extern bool AutoOnTop;

#define NOTFOUND i18n("Nothing found! Please try to mark the word exactly.\n")


unsigned char cgiHexValue[256]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,0,0,0,0,0,0,0,10,11,12,13,14,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,11,12,13,14,15,0,0,0};
char *cgiUnescape(char *cp, int len)
{
  char *s;
  int escapedValue = 0;
  int srcPos = 0;
  int dstPos = 0;
  s = new char[len + 1];
  int escapeState=0;
  if (!s) 
  {
    return NULL;
  }
  while (srcPos < len) 
  {
    int ch = cp[srcPos];
    switch (escapeState) 
    {
      case 0:
        if (ch == '%') 
        {
          escapeState = 1;
        } 
        else if (ch == '+') 
        {
          s[dstPos++] = ' ';
        } 
        else 
        {
          s[dstPos++] = ch;
        }
      break;
      case 1:
        escapedValue = cgiHexValue[ch] << 4;
        escapeState = 2;
      break;
      case 2:
        escapedValue += cgiHexValue[ch];
        s[dstPos++] = escapedValue;
        escapeState = 0;
      break;
    }
    srcPos++;
  }
  s[dstPos] = '\0';
  return s;
}

int main(int argc, char *argv[])
{
  char *query;
  if((query=getenv("QUERY_STRING"))!=NULL)
  {
    //CGI VERSION
    query=cgiUnescape(query,strlen(query));
    if(strstr(query,"q=")) query+=2;

    printf("Content-type: text/html; charset=UTF-8\r\n\r\n");
    printf("<html>\n<head>\n");
    printf("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n");
    printf("<TITLE>CGI-Quick</TITLE>\n</head>\n<body bgcolor=\"#fbf8f1\">");
    printf("<a href=\"http://www.futureware.at/quick.htm\"><img src=\"http://www.futureware.at/bilder/logoquick.png\" alt=\"*Quick Logo\" width=260 height=100 border=0></a>\n");
    printf("<form action=\"/cgi-bin/quick\" method=\"get\">\n");
    printf("Suche: <input size=40 maxlength=40 name=\"q\" value=\"%s\">\n",query);
    printf("</form><P>\n");
#if 0
    if (strlen(getenv("HTTP_REFERER")))
    {
      printf("<form action=\"/cgi-bin/page\" method=\"get\">\n");
      printf("&Uuml;berarbeite Seite: <input size=30 maxlength=100 name=\"q\" value=\"%s\">\n",getenv("HTTP_REFERER"));
      printf("</form><P>\n");
    }
#endif
    if(strlen(query))
    {
      Quick quick;
      OutputC *output;
      output=new OutputC();
      if (!quick.search(query,output,0))
        printf(NOTFOUND);
      output->write("</body></html>\n");
    }
    else
    {
      printf("Bitte den Suchtext als Parameter angeben.\n<p>");
      printf("Netscape <a href=\"javascript:myurl=&quot;http://quick.futureware.at/cgi-bin/quick?&quot;;window.open(myurl.concat(document.getSelection()),&quot;test&quot;);\">Browser Integration</a>:\n");
      printf("Dr&uuml;cken Sie &uuml;ber Browser Integration die rechte Maustaste, und dann &quot;Hinzuf&uuml;gen zu den Lesezeichen(Bookmarks)&quot; Nun k&ouml;nnen Sie einfach ein Wort markieren, und dann durch das Lesezeichen nach diesem Wort suchen.\n");
    }
  }
  else
  {
    //Console Version
    if(argc>1 && strcmp(argv[1],"-caption") && strcmp(argv[1],"-display"))
    {
      //There are still command line parameters, lets parse them!
      Quick quick;
      OutputC *output;
      output=new OutputC();
      if (!quick.search(argv[1],output,1))
        printf(NOTFOUND);
    }
    else
    {
    //KDE Version
      KApplication app(argc, argv, "kquick");
      KConfig *config=app.getConfig();
      config->setGroup(0);
      if (!config->hasKey("LogQueries"))
      {
        KMsgBox Frage;
        config->writeEntry("LogQueries",Frage.yesNo(0,i18n("kquick"),i18n("Shall all queries be logged and sent back to the developers?\n (You can change this setting in the options dialog.)"),0,i18n("Yes"),i18n("No"))==1);
      }
      logQueries=config->readBoolEntry("LogQueries");

      if (!config->hasKey("AutoOnTop")) config->writeEntry("AutoOnTop",true);
      AutoOnTop=config->readBoolEntry("AutoOnTop");

      if (app.isRestored())
      {
        RESTORE(KQuick);
      }
      else
      {
        KQuick *kquick = new KQuick();
        app.setMainWidget(kquick);
        kquick->show();
      }
      return app.exec();
    }
    return 0;
  }
}
